import java . math . BigInteger;



abstract class Instruction implements BigIntegerConstants
{



	static Instruction create (BigInteger x)
	{
		// x = 4 * u + r
		BigInteger [] dar = x . divideAndRemainder (FOUR);
		BigInteger u = dar [0];
		switch (dar [1] . intValue ())
		{
		case 0:
			return new Z_Instruction (u);
		case 1:
			return new S_Instruction (u);
		case 2:
			return new T_Instruction (u);
		case 3:
			return new J_Instruction (u);
		}
		throw new RuntimeException ("unreachable code");
	}



	abstract BigInteger get_code_number ();



}



