import java . math . BigInteger;



class J_Instruction extends Instruction
{



	final BigInteger src1, src2, target;



	J_Instruction (BigInteger u)
	{
		BigInteger pi1 = NaturalMath . pi1 (u);
		src1   = NaturalMath . pi1 (pi1) . add (ONE);
		src2   = NaturalMath . pi2 (pi1) . add (ONE);
		target = NaturalMath . pi2 (u)   . add (ONE);
	}



	J_Instruction (BigInteger src1, BigInteger src2, BigInteger target)
	{
		this . src1 = src1;
		this . src2 = src2;
		this . target = target;
	}



	BigInteger get_code_number ()
	{
		return FOUR . multiply (NaturalMath . pi (NaturalMath . pi (src1 . subtract (ONE), src2 . subtract (ONE)), target . subtract (ONE))) . add (THREE);
	}



	public String toString ()
	{
		return "J (" + src1 + ", " + src2 + ", " + target + ")";
	}



}



