import java . math . BigInteger;



class T_Instruction extends Instruction
{



	final BigInteger src, dest;



	T_Instruction (BigInteger u)
	{
		src  = NaturalMath . pi1 (u) . add (ONE);
		dest = NaturalMath . pi2 (u) . add (ONE);
	}



	T_Instruction (BigInteger src, BigInteger dest)
	{
		this . src = src;
		this . dest = dest;
	}



	BigInteger get_code_number ()
	{
		return FOUR . multiply (NaturalMath . pi (src . subtract (ONE), dest . subtract (ONE))) . add (TWO);
	}



	public String toString ()
	{
		return "T (" + src + ", " + dest + ")";
	}



}



