import java . math . BigInteger;



class Z_Instruction extends Instruction
{



	final BigInteger dest;



	Z_Instruction (BigInteger u)
	{
		dest = u . add (ONE);
	}



	Z_Instruction (BigInteger dest, boolean dummy)
	{
		this . dest = dest;
	}



	BigInteger get_code_number ()
	{
		return FOUR . multiply (dest . subtract (ONE));
	}



	public String toString ()
	{
		return "Z (" + dest + ")";
	}



}



