﻿using System;

namespace com.scrigner.RAMModel.Test
{
	public sealed class CProgramXMinus1 : CAbstractProgram 
	{
		// ====================================================================================
		// F(x) =	: x - 1		when x > 0
		//			: 0			when x == 0
		// ====================================================================================
		public CProgramXMinus1() : base (
			new IStatement[]
			{
				/* 01 */ new CStatementCondition(1,4,99),	// x == y --> jpm 7
				/* 02 */ new CStatementAddOne(3),			// k++
				/* 03 */ new CStatementCondition(1,3,7),	// x == k+1 --> jpm 7
				/* 04 */ new CStatementAddOne(2),			// k++
				/* 05 */ new CStatementAddOne(3),			// (k+1)++
				/* 06 */ new CStatementCondition(3),		// jpm 3
				/* 07 */ new CStatementTransfer(2,1)		// mov 3 -> 1
			})
		{}
	}
}
