﻿using System;

namespace com.scrigner.RAMModel
{
	public class CMachineStateEventArgs : EventArgs
	{
		private readonly IMachineState zPMachineState;

		public CMachineStateEventArgs(IMachineState machineState) : base ()
		{
			CContract.AssertIsNotNull("machineState", machineState);

			zPMachineState = machineState;
		}
		public IMachineState MachineState	{get{return zPMachineState;}}
	}
}
