﻿
namespace com.scrigner.RAMModel
{
	public class CStatementResult : IStatementResult
	{
		private readonly int ziNextStatementIndex;		// 0 means no NextStatementChanges

		public CStatementResult() //: this (0) 
		{
			ziNextStatementIndex = 0;
		}
		public CStatementResult(int iNextStatementIndex) 
		{
			CContract.Assert(iNextStatementIndex >= 1, "iNextStatementIndex >= 1");

			ziNextStatementIndex = iNextStatementIndex;
		}
		public int GetNextStatementIndex()	// Before calling this call HasNext !!
		{
			CContract.Assert(ziNextStatementIndex > 0, "ziNextStatementIndex > 0");

			return ziNextStatementIndex;
		}
		public bool HasNextStatementOverride()
		{
			return ziNextStatementIndex > 0;
		}
	}
}
