﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using com.scrigner.RAMModel.Parsing;
using System.Collections.Generic;

namespace com.scrigner.RAMModel.Parsing.Test
{
	// The following are NOT strict covering unit tests. They are just meant to test a few features and to show some code examples

	[TestClass]
	public class CStatementParserTest
	{
		// ==========================================================================================
		// XMinusOne Tests
		// ==========================================================================================
		[TestMethod]
		public void Parse()
		{
			string source = "s(1);s(2)";

			IProgram program = new CProgramParser().Parse(source);

			Assert.IsInstanceOfType(program.GetStatement(1), typeof(CStatementAddOne));
			Assert.IsInstanceOfType(program.GetStatement(2), typeof(CStatementAddOne));
		}
	}
}
