﻿using System;

namespace com.scrigner.RAMModel.Test
{
	public sealed class CProgramXMinusY_VersionA : CAbstractProgram 
	{
		// ====================================================================================
		// F(x) = 	: x - y		when x > 0
		//			: 0			when x == 0
		// ====================================================================================
		public CProgramXMinusY_VersionA() : base (
			new IStatement[]
			{
				/* 01 */ new CStatementCondition(1,2,5),	// x == y --> jmp 7
				/* 02 */ new CStatementAddOne(2),			// y++
				/* 03 */ new CStatementAddOne(3),			// k++
				/* 04 */ new CStatementCondition(1),		// jpm 3
				/* 05 */ new CStatementTransfer(3,1)		// mov 3 -> 1
			})
		{}
	}
}
